import es, cfglib, gamethread, playerlib, random

info = es.AddonInfo()
info.name = 'LooneyBotPing'
info.basename = info.name.lower()
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/LooneyBotPing'
info.author = 'Satoon101'
es.ServerVar('%s_version'%info.basename,info.version,'%s Version'%info.name).makepublic()

config = cfglib.AddonCFG(es.getAddonPath('looneybotping') + '/lbp_config.cfg')
lbp_max_ping = config.cvar('lbp_max_ping', 55, 'The highest ping that will be shown for Bots')
lbp_min_ping = config.cvar('lbp_min_ping', 25, 'The lowest ping that will be shown for Bots')
lbp_max_delay = config.cvar('lbp_max_delay', 3, 'Longest delay between ping updates for Bots')
lbp_min_delay = config.cvar('lbp_min_delay', 2, 'Shortest delay between ping updates for Bots')
config.write()

BotList = {}

class BotIndexes:
    def __init__(self, userid):
        self.userid = userid
        self.index = playerlib.getPlayer(self.userid).index
    
    def pingLoop(self):
        if not es.getuserid(self.userid): return
        es.setindexprop(player_manager, prop_base + '.%.3i'%self.index, random.randint(int(lbp_min_ping), int(lbp_max_ping)))
        gamethread.delayedname(random.randint(int(lbp_min_delay), int(lbp_max_delay)), 'lbp_Bot_%s_Ping'%self.userid, self.pingLoop)
    
    def removeLoop(self):
        gamethread.cancelDelayed('lbp_Bot_%s_Ping'%self.userid)

def getBot(userid):
    userid = str(userid)
    if not userid in BotList:
        BotList[userid] = BotIndexes(userid)
    return BotList[userid]

def load():
    config.execute()
    gamethread.queue(finishLoad)

def finishLoad():
    global player_manager, prop_base
    player_manager, prop_base = getPlayerManager()
    if player_manager is None:
        es.unload('looneybotping')
        raise NotImplementedError, 'LooneyBotPing does not support "%s"'%es.getGameName()
    for userid in playerlib.getUseridList('#bot'):
        getBot(userid).pingLoop()

def es_map_start(ev):
    clearBotList()

def unload():
    clearBotList()

def clearBotList():
    for userid in BotList:
        getBot(userid).removeLoop()
    BotList.clear()

def player_disconnect(ev):
    userid = ev['userid']
    if userid in BotList:
        getBot(userid).removeLoop()
        del BotList[userid]

def player_activate(ev):
    if 'bot' in str(ev['es_steamid']).lower():
        getBot(ev['userid']).pingLoop()

def getPlayerManager():
    entlist = es.createentitylist()
    for index in entlist:
        for prop in entlist[index]:
            if 'm_iping' in prop.lower(): return (index, prop.rsplit('.', 1)[0])
    return None, None
